package cpcns.utils;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import org.apache.commons.compress.archivers.ArchiveEntry;
import org.apache.commons.compress.archivers.zip.Zip64Mode;
import org.apache.commons.compress.archivers.zip.ZipArchiveEntry;
import org.apache.commons.compress.archivers.zip.ZipArchiveInputStream;
import org.apache.commons.compress.archivers.zip.ZipArchiveOutputStream;
import org.apache.commons.compress.utils.IOUtils;
import org.apache.tools.zip.ZipEntry;
import org.apache.tools.zip.ZipFile;

public class ZipUtil {
  public static void compressFiles2Zip(File[] files, String zipFilePath) {
    if (files != null && files.length > 0 && 
      isEndsWithZip(zipFilePath)) {
      ZipArchiveOutputStream zaos = null;
      try {
        File zipFile = new File(zipFilePath);
        zaos = new ZipArchiveOutputStream(zipFile);
        zaos.setUseZip64(Zip64Mode.AsNeeded);
        byte b;
        int i;
        File[] arrayOfFile;
        for (i = (arrayOfFile = files).length, b = 0; b < i; ) {
          File file = arrayOfFile[b];
          if (file != null) {
            ZipArchiveEntry zipArchiveEntry = new ZipArchiveEntry(
                file, file.getName());
            zaos.putArchiveEntry((ArchiveEntry)zipArchiveEntry);
            InputStream is = null;
            try {
              is = new FileInputStream(file);
              byte[] buffer = new byte[1048576];
              int len = -1;
              while ((len = is.read(buffer)) != -1)
                zaos.write(buffer, 0, len); 
              zaos.closeArchiveEntry();
            } catch (Exception e) {
              throw new RuntimeException(e);
            } finally {
              if (is != null)
                is.close(); 
            } 
          } 
          b++;
        } 
        zaos.finish();
      } catch (Exception e) {
        throw new RuntimeException(e);
      } finally {
        try {
          if (zaos != null)
            zaos.close(); 
        } catch (IOException e) {
          throw new RuntimeException(e);
        } 
      } 
    } 
  }
  
  public static void compressFile2Zip(File file, String zipFilePath) {
    if (isEndsWithZip(zipFilePath)) {
      ZipArchiveOutputStream zaos = null;
      try {
        File zipFile = new File(zipFilePath);
        zaos = new ZipArchiveOutputStream(zipFile);
        zaos.setUseZip64(Zip64Mode.AsNeeded);
        zaos.setEncoding("UTF-8");
        if (file != null) {
          ZipArchiveEntry zipArchiveEntry = new ZipArchiveEntry(file, file.getName());
          zaos.putArchiveEntry((ArchiveEntry)zipArchiveEntry);
          InputStream is = null;
          try {
            is = new FileInputStream(file);
            byte[] buffer = new byte[5120];
            int len = -1;
            while ((len = is.read(buffer)) != -1)
              zaos.write(buffer, 0, len); 
            zaos.closeArchiveEntry();
          } catch (Exception e) {
            throw new RuntimeException(e);
          } finally {
            if (is != null)
              is.close(); 
          } 
        } 
        zaos.finish();
      } catch (Exception e) {
        throw new RuntimeException(e);
      } finally {
        try {
          if (zaos != null)
            zaos.close(); 
        } catch (IOException e) {
          throw new RuntimeException(e);
        } 
      } 
    } 
  }
  
  public static void decompressZip(String zipFilePath, String saveFileDir) {
    File saveFile = new File(saveFileDir);
    if (!saveFile.exists())
      saveFile.mkdirs(); 
    if (isEndsWithZip(zipFilePath)) {
      File file = new File(zipFilePath);
      if (file.exists()) {
        InputStream is = null;
        ZipArchiveInputStream zais = null;
        try {
          is = new FileInputStream(file);
          zais = new ZipArchiveInputStream(is);
          ArchiveEntry archiveEntry = null;
          while ((archiveEntry = zais.getNextEntry()) != null) {
            String entryFileName = archiveEntry.getName();
            String entryFilePath = String.valueOf(saveFileDir) + "/" + entryFileName;
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            byte[] b = new byte[10240];
            int l = -1;
            while ((l = zais.read(b)) != -1)
              baos.write(b, 0, l); 
            byte[] bytes = baos.toByteArray();
            OutputStream os = null;
            OutputStreamWriter oswXml = null;
            try {
              if (entryFileName.indexOf(".eep") != -1 || entryFileName.indexOf(".EEP") != -1) {
                FileOutputStream xmlFos = new FileOutputStream(entryFilePath);
                oswXml = new OutputStreamWriter(xmlFos, "UTF-8");
                oswXml.write(new String(bytes, "UTF-8"));
              } else {
                File entryFile = new File(entryFilePath);
                os = new FileOutputStream(entryFile);
                os.write(bytes);
              } 
            } catch (IOException e) {
              throw new IOException(e);
            } finally {
              if (os != null) {
                os.flush();
                os.close();
              } 
              if (oswXml != null) {
                oswXml.flush();
                oswXml.close();
              } 
            } 
          } 
        } catch (Exception e) {
          throw new RuntimeException(e);
        } finally {
          try {
            if (zais != null)
              zais.close(); 
            if (is != null)
              is.close(); 
          } catch (IOException e) {
            throw new RuntimeException(e);
          } 
        } 
      } 
    } 
  }
  
  public static boolean isEndsWithZip(String fileName) {
    boolean flag = false;
    if (fileName != null && !"".equals(fileName.trim()) && (
      fileName.endsWith(".ZIP") || fileName.endsWith(".zip")))
      flag = true; 
    return flag;
  }
  
  public static void dirZip(String dir, String zippath) {
    List<String> paths = getFiles(dir);
    compressFilesZip(paths.<String>toArray(new String[paths.size()]), zippath, dir);
  }
  
  public static List<String> getFiles(String dir) {
    List<String> lstFiles = null;
    if (lstFiles == null)
      lstFiles = new ArrayList<>(); 
    File file = new File(dir);
    File[] files = file.listFiles();
    byte b;
    int i;
    File[] arrayOfFile1;
    for (i = (arrayOfFile1 = files).length, b = 0; b < i; ) {
      File f = arrayOfFile1[b];
      if (f.isDirectory()) {
        lstFiles.add(f.getAbsolutePath());
        lstFiles.addAll(getFiles(f.getAbsolutePath()));
      } else {
        String str = f.getAbsolutePath();
        lstFiles.add(str);
      } 
      b++;
    } 
    return lstFiles;
  }
  
  public static void compressFilesZip(String[] files, String zipFilePath, String dir) {
    if (files == null || files.length <= 0)
      return; 
    ZipArchiveOutputStream zaos = null;
    try {
      File zipFile = new File(zipFilePath);
      zaos = new ZipArchiveOutputStream(zipFile);
      zaos.setUseZip64(Zip64Mode.AsNeeded);
      byte b;
      int i;
      String[] arrayOfString;
      for (i = (arrayOfString = files).length, b = 0; b < i; ) {
        String strfile = arrayOfString[b];
        File file = new File(strfile);
        if (file != null) {
          ZipArchiveEntry zipArchiveEntry = new ZipArchiveEntry(file, file.getName());
          zaos.putArchiveEntry((ArchiveEntry)zipArchiveEntry);
          if (!file.isDirectory()) {
            InputStream is = null;
            try {
              is = new BufferedInputStream(new FileInputStream(file));
              byte[] buffer = new byte[1048576];
              int len = -1;
              while ((len = is.read(buffer)) != -1)
                zaos.write(buffer, 0, len); 
              zaos.closeArchiveEntry();
            } catch (Exception e) {
              throw new RuntimeException(e);
            } finally {
              if (is != null)
                is.close(); 
            } 
          } 
        } 
        b++;
      } 
      zaos.finish();
    } catch (Exception e) {
      throw new RuntimeException(e);
    } finally {
      try {
        if (zaos != null)
          zaos.close(); 
      } catch (IOException e) {
        throw new RuntimeException(e);
      } 
    } 
  }
  
  public static void unzip(String zipFilePath, String saveFileDir) {
    File dir = new File(saveFileDir);
    if (!dir.exists())
      dir.mkdirs(); 
    File file = new File(zipFilePath);
    if (file.exists()) {
      InputStream is = null;
      ZipArchiveInputStream zais = null;
      try {
        is = new FileInputStream(file);
        zais = new ZipArchiveInputStream(is);
        ArchiveEntry archiveEntry = null;
        while ((archiveEntry = zais.getNextEntry()) != null) {
          String entryFileName = archiveEntry.getName();
          String entryFilePath = String.valueOf(saveFileDir) + "/" + entryFileName;
          File entryFile = new File(entryFilePath);
          if (archiveEntry.isDirectory()) {
            entryFile.mkdirs();
            continue;
          } 
          FileOutputStream zaos = new FileOutputStream(entryFile);
          IOUtils.copy((InputStream)zais, zaos);
          zaos.close();
        } 
      } catch (Exception e) {
        e.printStackTrace();
      } finally {
        try {
          if (zais != null)
            zais.close(); 
          if (is != null)
            is.close(); 
        } catch (IOException e) {
          e.printStackTrace();
        } 
      } 
    } 
  }
  
  public static void packToolFiles(String dirpath, String zipFilePath) throws Exception {
    OutputStream out = null;
    BufferedOutputStream bos = null;
    ZipArchiveOutputStream zaos = null;
    File zipFile = new File(zipFilePath);
    if (!zipFile.getParentFile().exists())
      zipFile.getParentFile().mkdirs(); 
    zipFile.delete();
    try {
      out = new FileOutputStream(zipFile);
      bos = new BufferedOutputStream(out);
      zaos = new ZipArchiveOutputStream(bos);
      zaos.setUseZip64(Zip64Mode.AsNeeded);
      packToolFiles(zaos, dirpath, "");
    } catch (FileNotFoundException e) {
      e.printStackTrace();
    } finally {
      zaos.closeArchiveEntry();
      zaos.close();
      bos.flush();
      bos.close();
      out.flush();
      out.close();
    } 
  }
  
  private static void packToolFiles(ZipArchiveOutputStream zaos, String dirpath, String pathName) throws IOException {
    File dir = new File(dirpath);
    File[] files = dir.listFiles();
    if (files == null || files.length < 1)
      return; 
    for (int i = 0; i < files.length; i++) {
      File zFile = files[i];
      zaos.putArchiveEntry((ArchiveEntry)new ZipArchiveEntry(zFile, String.valueOf(pathName) + 
            zFile.getName()));
      if (zFile.isDirectory()) {
        packToolFiles(zaos, files[i].getAbsolutePath(), String.valueOf(pathName) + 
            zFile.getName() + "/");
      } else {
        FileInputStream in = new FileInputStream(zFile.getAbsolutePath());
        IOUtils.copy(in, (OutputStream)zaos);
        IOUtils.closeQuietly(in);
      } 
    } 
  }
  
  public static void unZipFiles(File zipFile, String descDir) throws IOException {
    File pathFile = new File(descDir);
    if (!pathFile.exists())
      pathFile.mkdirs(); 
    ZipFile zip = new ZipFile(zipFile);
    for (Enumeration<ZipEntry> entries = zip.getEntries(); entries.hasMoreElements(); ) {
      ZipEntry entry = entries.nextElement();
      String zipEntryName = entry.getName();
      InputStream in = zip.getInputStream(entry);
      String outPath = (String.valueOf(descDir) + zipEntryName).replaceAll("\\*", "/");
      File file = new File(outPath.substring(0, outPath.lastIndexOf('/')));
      if (!file.exists())
        file.mkdirs(); 
      if ((new File(outPath)).isDirectory())
        continue; 
      System.out.println(outPath);
      OutputStream out = new FileOutputStream(outPath);
      byte[] buf1 = new byte[1024];
      int len;
      while ((len = in.read(buf1)) > 0)
        out.write(buf1, 0, len); 
      in.close();
      out.close();
    } 
    System.out.println("******************解压完毕********************");
  }
}
